#include "mainwindow.h"

#include <QDebug>
#include <QDropEvent>
#include <QPushButton>
#include <QDrag>
#include <QMimeData>

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
{
    setAcceptDrops(true);

    QPushButton *button = new QPushButton("drag", this);

    connect(button, &QPushButton::pressed, this, [button] {
        QDrag *drag = new QDrag(button);

        drag->setMimeData(new QMimeData());
        drag->setPixmap(button->grab());
        drag->exec(Qt::MoveAction | Qt::CopyAction | Qt::LinkAction, Qt::CopyAction);
    });
}

MainWindow::~MainWindow()
{

}

void MainWindow::dragEnterEvent(QDragEnterEvent *event)
{
    event->acceptProposedAction();
}

void MainWindow::dragMoveEvent(QDragMoveEvent *event)
{
    event->acceptProposedAction();
}
